﻿//変数の宣言
var idx = 0;//┬プログラムの進行を管理
var tmr = 0;//┘

//プレイヤーキャラの移動処理を管理
var PLMF = 4;//何フレームで１マス動くか
var XP = [  0,  0, -1,  1 ];//各向き（上下左右）の座標変化値
var YP = [ -1,  1,  0,  0 ];
var plX = 7;//マップ配列上の座標
var plY = 7;
var plZ = 0;//どのマップにいるか
var plCX = plX*CHIP_SIZE;//キャンバスに描画するための座標
var plCY = plY*CHIP_SIZE;
var plD = 0;//キャラクターの向き
var plM = 0;//移動処理のフラグ（カウンター）

var worldX, worldY;//プレイヤーのワールドマップ上の座標（町やダンジョンの出入りで使用）

//マップデータの管理
var mapdata = [];
var mapname = "";
var mapW, mapH;
var mapAtt = [ 0, 0, 0, 0, 0 ];//マップの属性　範囲外は何番のチップにするかなど

function setMap() {//マップデータをセットする
 var mtop = 0;
 var loop = 0;
 while( true ) {//データの頭出し
  mapname = MAPDATA[mtop];
  mapW = MAPDATA[mtop+1];
  mapH = MAPDATA[mtop+2];
  if( loop == plZ ) break;
  loop ++;
  mtop = mtop + 8 + mapW*mapH;
 }
 for( var i = 0; i < mapW*mapH; i ++ ) mapdata[i] = MAPDATA[mtop+3+i];
 for( var i = 0; i < 5; i ++ ) mapAtt[i] = MAPDATA[mtop+3+mapW*mapH+i];
}

function chipNo( x, y ) {//マップチップの値を返す
 if( x < 0 || x >= mapW || y < 0 || y >= mapH ) return mapAtt[0];
 return mapdata[x+y*mapW];
}

function drawChip( cn, dx, dy ) {//マップチップを表示
 var sx = 1+(CHIP_SIZE+2)*(cn%10);
 var sy = 1+(CHIP_SIZE+2)*(toInt(cn/10));
 drawImgTS( 0, sx, sy, CHIP_SIZE, CHIP_SIZE, dx, dy, CHIP_SIZE, CHIP_SIZE );
}

//オブジェクトの管理
var OBJ_MAX = 100;
var objX = [], objY = [];//マップチップ上の座標
var objCX = [], objCY = [];//キャンバスに表示するための座標
var objP = [], objW = [], objH = [];//絵の番号、サイズ
var objD1 = [], objD2 = [], objD3 = [], objD4 = [];//各種のデータ
var objNum;//プレイヤーが載った（接した）オブジェクトの番号

function clrObj() {//全てのオブジェクトのクリア
 for( var i = 0; i < OBJ_MAX; i ++ ) objP[i] = -1;//※画像の値が-1の時、存在しないものとする
}

function setObj() {//オブジェクトデータをセットする
 var n = 0;
 var pos = 0;
 var loop = 0;
 while( true ) {//データの頭出し
  if( isNaN(OBJDATA[pos]) == true ) {
   if( loop == plZ ) break;
   loop ++;
  }
  pos ++;
 }
 pos ++
 while( true ) {
  if( isNaN(OBJDATA[pos]) == true ) break;
  objX[n]  = OBJDATA[pos+0];
  objY[n]  = OBJDATA[pos+1];
  objCX[n] = objX[n]*CHIP_SIZE;
  objCY[n] = objY[n]*CHIP_SIZE;
  objP[n]  = OBJDATA[pos+2];
  objW[n]  = OBJDATA[pos+3];
  objH[n]  = OBJDATA[pos+4];
  objD1[n] = OBJDATA[pos+5];
  objD2[n] = OBJDATA[pos+6];
  objD3[n] = OBJDATA[pos+7];
  objD4[n] = OBJDATA[pos+8];
  pos += 10;
  n ++;
 }
}

function chkObj() {//プレイヤーのいる場所にオブジェクトがあるか？
 var ret = -1;
 for( var i = 0; i < OBJ_MAX; i ++ ) {
  if( objP[i] >= 0 && objCX[i] == plCX && objCY[i] == plCY ) { ret = i; break; }
 }
 return ret;
}

function drawObj() {//オブジェクトを描画する
 for( var i = 0; i < OBJ_MAX; i ++ ) {
  if( objP[i] == -1 ) continue;
  var x = objCX[i]-plCX;//プレイヤーキャラとの相対座標
  var y = objCY[i]-plCY;
  x -= ( objW[i]-CHIP_SIZE )/2;//画像のセンタリング
  y -= ( objH[i]-CHIP_SIZE )/2;
  if( -9*CHIP_SIZE < x && x < 9*CHIP_SIZE && -9*CHIP_SIZE < y && y < 9*CHIP_SIZE ) drawImg( objP[i], x+(7*CHIP_SIZE), y+(7*CHIP_SIZE-16) );
 }
}

//マップ（ＢＧ）の描画
var mapL, mapT, ofsX, ofsY;
function drawBG() {
 var x, y;
 mapL = toInt(plCX/CHIP_SIZE)-7;
 mapT = toInt(plCY/CHIP_SIZE)-7;
 ofsX = -(plCX%CHIP_SIZE);
 ofsY = -(plCY%CHIP_SIZE);
 for( y = -1; y < 16; y ++ ) {
  for( x = -1; x < 16; x ++ ) drawChip( chipNo(mapL+x,mapT+y), x*CHIP_SIZE+ofsX, y*CHIP_SIZE+ofsY );
 }
}

function drawChr( cn, dx, dy, dir ) {//キャラクターの表示
 var sx = 48*(toInt(tmr/4)%2);
 var sy = 72*dir;
 drawImgTS( cn, sx, sy, 48, 72, dx, dy, 48, 72 );
}

//ヴァーチャルキーの表示と入力判定
var vkey = 0;
function virtualKey() {
 var k = 0;
 if( winW > winH ) {
  fRect( 720, 0, 240, 720, "gray" );
  drawBtn( "↑", 840,  90, 240-2, 180-2, 32, "white", 0 ); if( btn_on[0] > 0 ) k = 38;
  drawBtn( "↓", 840, 630, 240-2, 180-2, 32, "white", 1 ); if( btn_on[1] > 0 ) k = 40;
  drawBtn( "←", 780, 360, 120-2, 360-2, 32, "white", 2 ); if( btn_on[2] > 0 ) k = 37;
  drawBtn( "→", 900, 360, 120-2, 360-2, 32, "white", 3 ); if( btn_on[3] > 0 ) k = 39;
 }
 else {
  fRect( 0, 720, 720, 240, "black" );
  drawBtn( "↑", 360, 780, 360-2, 120-2, 32, "white", 0 ); if( btn_on[0] > 0 ) k = 38;
  drawBtn( "↓", 360, 900, 360-2, 120-2, 32, "white", 1 ); if( btn_on[1] > 0 ) k = 40;
  drawBtn( "←",  90, 840, 180-2, 240-2, 32, "white", 2 ); if( btn_on[2] > 0 ) k = 37;
  drawBtn( "→", 630, 840, 180-2, 240-2, 32, "white", 3 ); if( btn_on[3] > 0 ) k = 39;
 }
 if( k > 0 ) vkey = k; else vkey = 0;
}

//ブラウザのサイズが変化した時（スマホなら縦持ち⇔横持ち）
//CWIDTH,CHEIGHT,SCALE,winW,winH変数はシステムで定義されている
function resizeCanvas() {
 var cw, ch;
 if( winW < winH ) {//縦長の画面
  CWIDTH = 720;
  CHEIGHT = 960;
  cw = winW;
  ch = toInt(winW*CHEIGHT/CWIDTH);
  SCALE = winW / CWIDTH;
 }
 else {
  CWIDTH = 960;
  CHEIGHT = 720;
  cw = toInt(winH*CWIDTH/CHEIGHT);
  ch = winH;
  SCALE = winH / CHEIGHT;
 }
 canvas.width = cw;
 canvas.height = ch;
 bg.scale(SCALE,SCALE);
 bg.textAlign = "center";
 bg.textBaseline = "middle";
}

//メイン処理　※メインループはWWSシステムが担っている
function mainProc() {
 var i, x, y, w, h;
 tmr ++;

 switch( idx ) {
  case 0://初期化処理
  resizeCanvas();
  setMap();
  setObj();
  idx = 1;
  break;

  case 1://プレイヤーキャラの移動
  if( plM == 0 ) {//停止中
   plCX = plX*CHIP_SIZE;
   plCY = plY*CHIP_SIZE;
   objNum = chkObj();
   if( objNum >= 0 ) {//町やダンジョンに入る
    idx = 2;
    tmr = 0;
    break;
   }
   if( plX < 0 || plX >= mapW || plY < 0 || plY >= mapH ) {//ワールドマップに戻る
    idx = 2;
    tmr = 0;
    break;
   }
   if( inkey == 38 || vkey == 38 ) { plD = 0; if( WALL[ chipNo(plX,plY-1) ] == 0 ) { plY--; plM = 1; } }
   if( inkey == 40 || vkey == 40 ) { plD = 1; if( WALL[ chipNo(plX,plY+1) ] == 0 ) { plY++; plM = 1; } }
   if( inkey == 37 || vkey == 37 ) { plD = 2; if( WALL[ chipNo(plX-1,plY) ] == 0 ) { plX--; plM = 1; } }
   if( inkey == 39 || vkey == 39 ) { plD = 3; if( WALL[ chipNo(plX+1,plY) ] == 0 ) { plX++; plM = 1; } }
  }
  else {//移動中
   plCX = (plX-XP[plD])*CHIP_SIZE + XP[plD]*CHIP_SIZE*plM/PLMF;
   plCY = (plY-YP[plD])*CHIP_SIZE + YP[plD]*CHIP_SIZE*plM/PLMF;
   plM ++;
   if( plM >= PLMF ) plM = 0;
  }
  drawBG();
  drawObj();
  drawChr( 1, 7*CHIP_SIZE, 7*CHIP_SIZE-CHIP_SIZE/2, plD );//勇者
  virtualKey();
  break;

  case 2://マップ切り替え
  drawBG();
  drawObj();
  drawChr( 1, 7*CHIP_SIZE, 7*CHIP_SIZE-CHIP_SIZE/2, plD );//勇者
  virtualKey();
  if( tmr == 1 ) {
   if( plZ == 0 ) { worldX = plX; worldY = plY; }
  }
  if( tmr <= 20 ) fRect( 0, 0, CHIP_SIZE*15, CHIP_SIZE*15, "rgba(0,0,0,"+0.05*tmr+")" );
  if( tmr >  20 ) fRect( 0, 0, CHIP_SIZE*15, CHIP_SIZE*15, "rgba(0,0,0,"+0.05*(40-tmr)+")" );
  if( tmr == 20 ) {
   if( plZ > 0 ) {//ワールドマップに戻る
    plX = worldX;
    plY = worldY+1;
    plZ =  0;
    plD =  1;
   }
   else {//町やダンジョンに入る
    plZ = objD1[objNum];
    plX = objD2[objNum];
    plY = objD3[objNum];
    plD = objD4[objNum];
   }
   plCX = plX*CHIP_SIZE;
   plCY = plY*CHIP_SIZE;
   clrObj();
   setObj();
   setMap();
  }
  if( tmr == 40 ) {
   idx = 1;
  }
  break;

 }

//★★★デバッグ
fText( mapname, 100, 30, 24, "white" );
if( plM == 0 ) fText( chkObj(), 100, 60, 24, "yellow" );

 //ブラウザのサイズが変化したか？（スマホなら持ち方を変えたか　縦持ち⇔横持ち）
 w = window.innerWidth;
 h = window.innerHeight;
 if( winW != w || winH != h ) {
  winW = w;
  winH = h;
  resizeCanvas();
 }

}

//【メモ】メイン処理と描画処理を分ける場合、描画処理をここに記載
function drawProc() {}
